package com.qmth.qrzk.dao.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.qmth.qrzk.dao.IQuestionOperationLogDao;
import com.qmth.qrzk.dao.IQuestionPagerTimesDao;
import com.qmth.qrzk.repository.common.mapper.QuestionPagerTimesMapper;
import com.qmth.qrzk.repository.user.model.QuestionPagerTimes;
/**
 * 试题启用日志时间表
 * @author sunrao
 *
 */
@Repository("questionPagerTimesDaoImpl")
@Transactional
public class QuestionPagerTimesDaoImpl implements IQuestionPagerTimesDao {

	@Autowired
	@Qualifier("questionPagerTimesMapper")
	private QuestionPagerTimesMapper questionPagerTimesMapper;
	
	@Override
	public int insert(QuestionPagerTimes qol) {
		return questionPagerTimesMapper.saveLog(qol);
	}

	@Override
	public List<QuestionPagerTimes> query(QuestionPagerTimes qol) {
		// TODO Auto-generated method stub
		return questionPagerTimesMapper.queryIds(qol);
	}

	@Override
	public List<QuestionPagerTimes> queryTimesLogs(int id) {
		// TODO Auto-generated method stub
		return questionPagerTimesMapper.queryTimesLogs(id);
	}

}
