package com.qmth.qrzk.repository.common.mapper;

import java.util.List;

import org.springframework.stereotype.Component;

import com.qmth.qrzk.repository.service.query.UserQueryParams;
import com.qmth.qrzk.repository.user.model.ImportBean;
import com.qmth.qrzk.repository.user.model.User;

/**
 * 用户mapper对应src/main/resources/sqlmap下的user.xml配置文件
 * @author 钟辉
 *
 */
@Component("userMapper")
public interface UserMapper extends CommonMapper{
	public List<User> findUser(User user);
	
	public int updateLastLoginDate(User user);
	
	public int updatePassword(User user);
	
	public User findUserByUsername(String userName);
	
	public List<User> getUserListByPaginationAndSort();
	
	public int getUserCount();
	
	public List<User> findUserByCourseIds(List<Integer> list);
	
	public int insertUserList(List<User> list );
	
	public int queryNameFromList(List<ImportBean> list);
	
	public List<User> queryName(String name);
	
	public List<User> queryUsers(UserQueryParams params);
	
	public int queryUsersCount(UserQueryParams params);
	
	public int insertUser(User user);
	
	public int checkUserName(User user);
	
	public int updateStatus(User user);
	
	public User findUserById(int id);
	
	public void updateUser(User user);
	
	public int checkPassword(User user);
	
	public List<User> getCanSetByUsers(int courseId);
}
