package com.qmth.qrzk.repository.explort.beans;

import java.io.Serializable;
import java.util.Date;

/**
 * 导入试题的基类 包含试题类集合、选项类集合、附件类集合
 * @author 钟辉
 *
 */
public class ExportQuestionSet implements  Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = -2846963953142443516L;

	// 导出时间
    public Date dt;

    // 随机 uuID
    public String uuid;
    public String name; // 命题集名称

    // 发送程序版本号, 必须与接受程序版本号一至
    public String program_version;
    // 暂为0
    public String file_version;

    // 展开口令 如果有加密则使用该口令对数据进行解密
    public String expand_password;
    // 以下为压缩加密内容
    // 压缩类型 全小写 空为不压缩
    // 压缩类型 "", "zip", "7z", "cab", "rar"
    public String compression_type;

    // 私有公有加密密钥 全大写 空为不加密
    // 加密类型 "", "MD5" , "SHA1", "DES", "AES", "RSA"
    public String encryption_type;
    public String public_key;
    public String private_key;

    // 基础信息表 为XML格式, 为保证不同数据库的统一性
    // <course>
    //    <key field='name'>value</key>
    // </course>
    public String base_architecture;

    // 本文件长度
    public long file_size;

    // hasmd5 校验, 最后写入
    public String md5;

    public ExportQuestion[] questions;

	public Date getDt() {
		return dt;
	}

	public String getUuid() {
		return uuid;
	}

	public String getName() {
		return name;
	}

	public String getProgram_version() {
		return program_version;
	}

	public String getFile_version() {
		return file_version;
	}

	public String getExpand_password() {
		return expand_password;
	}

	public String getCompression_type() {
		return compression_type;
	}

	public String getEncryption_type() {
		return encryption_type;
	}

	public String getPublic_key() {
		return public_key;
	}

	public String getPrivate_key() {
		return private_key;
	}

	public String getBase_architecture() {
		return base_architecture;
	}

	public long getFile_size() {
		return file_size;
	}

	public String getMd5() {
		return md5;
	}

	public ExportQuestion[] getQuestions() {
		return questions;
	}
    
    
}
