package com.qmth.qrzk.web.listener;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextRefreshedEvent;

import com.qmth.qrzk.repository.quartz.LoadParamsQuartz;

public class LoadConfListener  implements ApplicationListener<ContextRefreshedEvent>{
	
	@Autowired
	private LoadParamsQuartz loadParamsQuartz;

	@Override
	public void onApplicationEvent(ContextRefreshedEvent event) {
		
		//因为涉及到springmvc和 spring2个容器一个是root application context ,另一个就是我们自己的 projectName-servlet  context
		//这种情况下，就会造成onApplicationEvent方法被执行两次。为了避免上面提到的问题，我们可以只在root application context初始化完成后调用逻辑代码，其他的容器的初始化完成，则不做任何处理
		if(event.getApplicationContext().getParent()==null){
			loadParamsQuartz.loadParamsAndCache();
//			loadParamsQuartz.loadLuceneIndex();
		}
	}
}
